#include <e32std.h>
#include <eikenv.h>
#include <wolf3d.rsg>
#include "version.h"

#ifdef S60V3
#include <akncommondialogs.h> 
#include <caknfileselectiondialog.h> 
#include <maknfileselectionobserver.h> 
#elif defined (UIQ3)
#include <QikSelectFolderDlg.h>
#else
#endif

#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <bautils.h>
#include <eikenv.h>
#include <stdlib.h>
#include <string.h>

#if defined (EPOC_AS_APP) && !defined (UIQ3) && !defined(S60V3)
#include "ECompXL.h"
#endif

class CWolf3DApp : public CSDLApp {
public:
	CWolf3DApp();
	~CWolf3DApp();

	TUid AppDllUid() const;
#if defined (EPOC_AS_APP)  && !defined (UIQ3) && !defined(S60V3)
	TECompXL    iECompXL;
#endif

#if defined (UIQ3) 
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif

};

#ifdef EPOC_AS_APP

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined(S60V3)
EXPORT_C 
#endif
CApaApplication* NewApplication() {
	return new CWolf3DApp;
}

#if defined (UIQ3) || defined (S60V3)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (S60V3)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif
CWolf3DApp::CWolf3DApp() {
}

CWolf3DApp::~CWolf3DApp() {
}

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CWolf3DApp::AppDllUid() const {
	
	return TUid::Uid(0xF01F62f6);
}
#if defined (UIQ3)
#include <Wolf3d.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CWolf3DApp::ViewResourceId() {
	
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////

#include <unistd.h>

TBuf8<256> gGameDir;

extern "C" 
const char* SelectGameDir()
{
	TFileName gamePath;
#ifdef SPEAR
#ifdef SPEARDEMO
	 TBuf<64> title =  _L("Locate SoD Demo");
#else
	 TBuf<64> title =  _L("Locate SoD");
#endif
#elif defined (UPLOAD)
	 TBuf<64> title =  _L("Locate Wolf3D WL1");
#else
	 TBuf<64> title =  _L("Locate Wolf3D WL6");
#endif


#ifdef UIQ3
	 if(!CQikSelectFolderDlg::RunDlgLD(gamePath, NULL))
#elif defined(S60V3)
	if(!AknCommonDialogs::RunSelectDlgLD(gamePath, 0, title))
#else
	 CEikFileOpenDialog* dlg = new (ELeave) CEikFileOpenDialog(&gamePath,R_FILE_TITLE);
	 if(!dlg->ExecuteLD(R_EIK_DIALOG_FILE_OPEN))
#endif
	 {
		 gamePath.Zero();		
	 }
	 else
	 {
		 TParsePtr parser(gamePath);
		 gamePath = parser.DriveAndPath();
	 }

	gGameDir.Copy(gamePath);
	return (const char*) gGameDir.PtrZ();

}

extern "C" const char* GameDir()
{
	return (const char*) gGameDir.PtrZ();
}
